<template>
  <a-card :bordered='false'>
    <div class='table-page-search-wrapper'>
      <a-form layout='inline'>
        <a-row :gutter='48'>
          <a-col :md='5' :sm='15'>
            <a-form-item label='主题'>
              <a-input placeholder='请输入主题' v-model='queryParam.title' />
            </a-form-item>
          </a-col>
          <a-col :md='5' :sm='15'>
            <a-form-item label='预约状态'>
              <a-select v-model='queryParam.statusValue' placeholder='请选择会议室'>
                <a-select-option v-for='item in meetingStatusList' :key='item.value' :value='item.value'>
                  {{ item.label }}
                </a-select-option>
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :md='8' :sm='24'>
            <span class='table-page-search-submitButtons'>
              <a-button type='primary' @click='$refs.table.refresh(true)'>查询</a-button>
              <a-button style='margin-left: 8px' @click='() => queryParam = {}'>重置</a-button>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>
    <div class='table-operator'>
      <a-button v-if='addEnable' type='primary' icon='plus' @click='$refs.modal.add()'>会议预约</a-button>
      <a-dropdown v-if='removeEnable&&selectedRowKeys.length > 0'>
        <a-button type='danger' icon='delete' @click='delByIds(selectedRowKeys)'>删除</a-button>
      </a-dropdown>
    </div>
    <s-table
      size='default'
      ref='table'
      rowKey='id'
      :rowSelection='{selectedRowKeys: selectedRowKeys, onChange: onSelectChange}'
      :columns='columns'
      :data='loadData'
      :scroll='{ x: true }'
    >
      <span slot='action' slot-scope='text, record'>
        <a @click='handleInfo(record)'>详情</a>
        <a-divider type='vertical' />
        <a v-if='editEnabel && (record.statusValue == 0 || record.statusValue == 1)' @click='handleEdit(record)'>修改</a>
        <a-divider type='vertical'/>
        <a v-if='removeEnable' @click='delByIds([record.id])'>删除</a>
        <a-divider type='vertical'/>
         <a-tag  @click='verifySuccess(record.id)' v-if='successEnable && record.statusValue == 0' color='green'>通过</a-tag>
        <a-divider type='vertical'/>
         <a-tag  @click='verifyReject(record.id)' v-if=' rejectEnable && (record.statusValue == 0 || record.statusValue == 1) '
                color='volcano'>驳回</a-tag>
      </span>
    </s-table>
    <reservation-modal ref='modal' @ok='handleOk' />


    <a-modal
      title='驳回'
      :visible='rejectModalVisible'
      :confirm-loading='rejectConfirmLoading'
      @ok='rejectHandleOk'
      @cancel='rejectHandleCancel'
      cancelText='取消'
      okText='确认'
    >
      <div class='rejectView'>
        <div class='label'>驳回原因</div>
        <a-input class='content' v-model='rejectContent' placeholder='请输入驳回原因' />
      </div>
    </a-modal>
  </a-card>
</template>

<script>
import { STable } from '@/components'

import { delReservation, getReservationList, saveReservation } from '@/api/admin/meeting/reservation'
import ReservationModal from './modules/ReservationModal.vue'
import { checkPermission } from '@/utils/permissions'

export default {
  name: 'TableList',
  components: {
    STable,
    ReservationModal
  },
  data() {
    return {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 5 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 }
      },
      form: this.$form.createForm(this),
      mdl: {},
      // 高级搜索 展开/关闭
      advanced: false,
      // 查询参数
      queryParam: {
        title: null,
        statusValue: null
      },
      // 表头
      columns: [
        {
          title: '会议主题',
          dataIndex: 'title',
          fixed: 'left'
        },
        {
          title: '会议室名称',
          dataIndex: 'roomContent.meetingName',
          fixed: 'left'
        },
        {
          title: '会议类型',
          dataIndex: 'roomContent.typeName'
        },
        {
          title: '预约人',
          dataIndex: 'userName'
        },
        {
          title: '所属企业',
          dataIndex: 'customerName'
        },
        {
          title: '会议开始时间',
          dataIndex: 'startTime'
        },
        {
          title: '会议结束时间',
          dataIndex: 'endDate'
        },
        {
          title: '时长',
          dataIndex: 'roomContent.duration'
        },
        {
          title: '金额',
          dataIndex: 'orderMoney'
        },
        {
          title: '支付状态',
          dataIndex: 'isPay'
        },
        {
          title: '预约状态',
          dataIndex: 'statusName'
        },
        {
          title: '操作',
          width: '280px',
          dataIndex: 'action',
          scopedSlots: { customRender: 'action' },
          fixed: 'right'
        }
      ],
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        return getReservationList(Object.assign(parameter, this.queryParam))
      },
      selectedRowKeys: [],
      selectedRows: [],
      addEnable: checkPermission('meeting:reservation:add'),
      editEnabel: checkPermission('meeting:reservation:edit'),
      removeEnable: checkPermission('meeting:reservation:remove'),
      rejectEnable: checkPermission('meeting:reservation:reject'),
      successEnable: checkPermission('meeting:reservation:success'),
      rejectModalVisible: false,
      rejectConfirmLoading: false,
      rejectModalId: null,
      rejectContent: null,
      meetingStatusList: [
        {
          label: '全部',
          value: null
        },
        {
          label: '待支付',
          value: 0
        },
        {
          label: '待使用',
          value: 1
        },
        {
          label: '进行中',
          value: 2
        },
        {
          label: '已结束',
          value: 3
        },
        {
          label: '已取消',
          value: 4
        }
      ]
    }
  },
  filters: {},
  created() {
  },
  methods: {
    onSelectChange(selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },
    //详情，跳转页面
    handleInfo(record) {
      console.log('详情 handleInfo' , record)
      this.$router.push({ name: 'reservationInfo', query: { id: record.id } })
    },
    handleAdd() {
      this.$refs.modal.add()
    },
    handleEdit(record) {
      this.$refs.modal.edit(record)
    },
    handleOk() {
      this.$refs.table.refresh(true)
      console.log('handleSaveOk')
    },
    delByIds(ids) {
      delReservation({ ids: ids.join(',') }).then(res => {
        if (res.code === 0) {
          this.$message.success('删除成功')
          this.handleOk()
        } else {
          this.$message.error(res.msg)
        }
        this.selectedRowKeys = []
      })
    },
    verifySuccess(id) {
      saveReservation({
        id,
        stauts: 1
      }).then(res => {
        if (res.code === 0) {
          this.$message.success('审核通过')
          this.handleOk()
        } else {
          this.$message.error(res.msg)
        }
        this.selectedRowKeys = []
      })
    },
    verifyReject(id) {
      this.rejectModalId = id
      this.rejectModalVisible = true
    },
    rejectHandleOk() {
      console.log('rejectHandleOk', this.rejectContent)
      let id = this.rejectModalId
      let cancelResaon = this.rejectContent
      // 校验必填
      if (!this.rejectContent) {
        this.$message.error('驳回原因不能为空!')
        return
      }
      // 设置确认加载状态
      this.rejectConfirmLoading = true
      // 调用接口
      saveReservation({
        id,
        stauts: 4,
        cancelResaon
      }).then(res => {
        if (res.code === 0) {
          this.$message.success('操作成功')
          this.rejectHandleCancel()
          this.handleOk()
        } else {
          this.$message.error(res.msg)
        }
        this.selectedRowKeys = []
      })
    },
    rejectHandleCancel() {
      this.rejectModalId = null
      this.rejectModalVisible = false
      this.rejectConfirmLoading = false
      this.rejectContent = null
    }
  },
  watch: {
    /*
      'selectedRows': function (selectedRows) {
        this.needTotalList = this.needTotalList.map(item => {
          return {
            ...item,
            total: selectedRows.reduce( (sum, val) => {
              return sum + val[item.dataIndex]
            }, 0)
          }
        })
      }
      */
  }
}
</script>

<style scoped>


.rejectView {
  display: flex;
  justify-content: flex-start;
  align-items: center;
}

.rejectView .label {

}

.rejectView .content {
  flex: 1;
  margin-left: 10px;
}

</style>